<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00011000ApuracaoFaturamentoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getApuracaoFaturamento(array $params, $dynamicFilter)
    {
        $sql = "SELECT DISTINCT AGRUPCONT.IDPARCAGRUP,
                    TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                    DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, 'AGRUPAMENTO') AS NRCONTRATOFCT,
                    DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT, 'AGRUPAMENTO') AS NMCONTRATO,
                    CASE AGRUPCONT.IDPARCAGRUP
                        WHEN 'N' THEN TO_CHAR(CONT.NRSEQCONTRATO) ELSE
                            (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP(
                                                                                ORDER BY NRSEQCONTRATO)
                                FROM FCT_RELACAGRUPCONTFAT
                                WHERE NRFATURACONT = FAT.NRFATURACONT)
                    END AS NRSEQCONTRATO,
                    FAT.NRFATURACONT,
                    FAT.CDFILIALFATURA,
                    FILIFAT.NMFILIAL AS NMFILIALFATURA,
                    FAT.NRPARCFATURA,
                    PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA,
                    PARCFAT.NRINSCRICAOPARC,
                    PARCFAT.NMSECUNDARIPARC AS NMFANTASIA,
                    FAT.IDTPFATURA,
                    FAT.IDSITUACAO,
                    DECODE(IDTPFATURA, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', '-/-', FAT.NRPARCELA || '/' ||
                                                    (SELECT COUNT(FCT_FATURACONT.NRFATURACONT) AS CONTADOR
                                                    FROM FCT_FATURACONT
                                                    JOIN FCT_RELACAGRUPCONTFAT ON FCT_RELACAGRUPCONTFAT.NRFATURACONT = FCT_FATURACONT.NRFATURACONT
                                                    AND FCT_RELACAGRUPCONTFAT.NRORG = FCT_FATURACONT.NRORG
                                                    WHERE FCT_RELACAGRUPCONTFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                                                        AND FCT_FATURACONT.IDTPFATURA = 'P')), NULL) AS NRPARCELA,
                    TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS DTINICOMPET,
                    TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS DTFINCOMPET,
                    TO_CHAR(FAT.DTLIMITEAPU, 'DD/MM/YYYY') AS DTLIMITEAPU,
                    FAT.DTVENCIMENTO,
                    FAT.NRDIASVENCIMENTO,
                    FAT.QTDIASFATUVENC,
                    FAT.VRVENCIMENTO,
                    FAT.VRFATURADO,
                    FAT.VRFALTAFATURAR,
                    FAT.IDFORMAFATURA,
                    FAT.IDALTUSUARIO,
                    FAT.NRAPURACAO,
                    NF.NRLANCTONF,
                    NF.CDFILIAL AS CDFILIALNF,
                    FILINF.NMFILIAL AS NMFILIALNF,
                    NF.NRNOTAFISC,
                    NF.DTENTRSAID,
                    NF.VRNOTAFISC,
                    FAT.IDATIVO,
                    FAT.NRORG,
                    FAT.DTINCLUSAO,
                    FAT.NRORGINCLUSAO,
                    FAT.CDOPERINCLUSAO,
                    FAT.DTULTATU,
                    FAT.NRORGULTATU,
                    FAT.CDOPERULTATU,
                    FAT.CDTIPOOPERFATURA,
                    FAT.CDSERIENF,
                    FAT.CDEMPRESA,
                    FAT.CDINSCESTA,
                    FAT.CDINSCMUNI,

            (SELECT IDGERARATEIO
            FROM FCT_CAPAPARAMFATESC
            WHERE NRTIPOORCAMENTO = NVL(CONT.NRTIPOORCAMENTO, REFE.NRTIPOORCAMENTO)
            AND NRORG = CONT.NRORG) AS IDGERARATEIO,

            (SELECT COUNT(*)
            FROM FCT_RATEIOITFATURACONT
            WHERE NRFATURACONT = FAT.NRFATURACONT
            AND NRORG = FAT.NRORG) AS TOTALDERATEIOS,
                    NF.DSTIPOAPURACAO,
                    FCT_TIPOORCAMENTO.NRTIPOORCAMENTO,
                    FCT_TIPOORCAMENTO.NMTIPOORCAMENTO,
                    FAT.VRNEGCONTR,
                    FAT.NRPARCELASNEGCONTR,
                    FAT.NRESTRUTURAM,
                    EST.NMESTRUTURAM,
                    FAT.CDTRIBPRODPADR,
                    FAT.CDPAISFAT,
                    FAT.SGESTADOFAT,
                    FAT.CDMUNICIPIOFAT,
                    MUN.NMMUNICIPIO AS NMMUNICIPIOFAT,
                    FAT.IDNATUOPER
            FROM FCT_FATURACONT FAT
            INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
            AND FAT.NRORG = AGRUPCONT.NRORG
            LEFT JOIN FCT_CONTRATO CONT ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
            AND AGRUPCONT.NRORG = CONT.NRORG
            LEFT JOIN FCT_REFEORCACONT REFE ON CONT.NRSEQCONTRATO = REFE.NRSEQCONTRATO
            AND CONT.NRORG = REFE.NRORG
            INNER JOIN FILIAL FILIFAT ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
            AND FAT.NRORG = FILIFAT.NRORG
            INNER JOIN PARCNEGOCIO PARCFAT ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
            AND FAT.NRORG = PARCFAT.NRORG
            LEFT JOIN FCT_TIPOORCAMENTO ON (CONT.NRTIPOORCAMENTO = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
                                    OR REFE.NRTIPOORCAMENTO = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO)
            AND FCT_TIPOORCAMENTO.NRORG = CONT.NRORG
            LEFT JOIN
            (SELECT APURFAT.NRFATURACONT,
            LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP (
                                                        ORDER BY NF.NRLANCTONF) AS NRLANCTONF,
                                                        NF.CDFILIAL,
                                                        LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP (
                                                                                                ORDER BY NF.NRLANCTONF) AS NRNOTAFISC,
                                                                                                LISTAGG(TRIM(TO_CHAR(NF.VRNOTAFISC, '999G999G999G999D99', 'NLS_NUMERIC_CHARACTERS = '',.'' ')), ', ') WITHIN GROUP (
                                                                                                                                                                                                                    ORDER BY NF.NRLANCTONF) AS VRNOTAFISC,
                                                                                                                                                                                                                    NF.DTENTRSAID,
                                                                                                                                                                                                                    APURFAT.NRORG,
                                                                                                                                                                                                                    APU.DSTIPOAPURACAO
            FROM FCT_RELACAPURACAOFATURA APURFAT
            INNER JOIN FCT_APURACAO APU ON APURFAT.NRAPURACAO = APU.NRAPURACAO
            AND APURFAT.NRORG = APU.NRORG
            LEFT JOIN NOTAFISCAL NF ON APU.NRLANCTONF = NF.NRLANCTONF
            AND APU.CDFILIAL = NF.CDFILIAL
            GROUP BY NF.CDFILIAL,
                APURFAT.NRFATURACONT,
                NF.DTENTRSAID,
                APURFAT.NRORG,
                APU.DSTIPOAPURACAO) NF ON FAT.NRFATURACONT = NF.NRFATURACONT
            AND FAT.NRORG = NF.NRORG
            LEFT JOIN FILIAL FILINF ON NF.CDFILIAL = FILINF.CDFILIAL
            LEFT JOIN ESTRUTURAM EST ON FAT.NRESTRUTURAM = EST.NRESTRUTURAM
            LEFT JOIN MUNICIPIO MUN ON FAT.CDPAISFAT = MUN.CDPAIS
            AND FAT.SGESTADOFAT = MUN.SGESTADO
            AND FAT.CDMUNICIPIOFAT = MUN.CDMUNICIPIO WHERE(((INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(CONT.NRSEQCONTRATO) || '_') > 0)
                                                    OR (:NRSEQCONTRATO IS NULL)))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params, [], null, null, null, $dynamicFilter);
    }

    public function getFilialFatura()
    {
        $sql = "SELECT FAT.CDFILIALFATURA, FL.NMFILIAL AS NMFILIALFATURA
                FROM FCT_FATURACONT FAT
                JOIN FILIAL FL ON FAT.CDFILIALFATURA = FL.CDFILIAL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getNrNotaFiscal($parametro)
    {
        $sql = "SELECT NOTAFISCAL.CDFILIAL,
                FILIAL.NMFILIAL,
                FILIAL.CDEMPRESA,
                NOTAFISCAL.NRLANCTONF,
                NOTAFISCAL.NRNOTAFISC,
                NOTAFISCAL.CDCLIENTE,
                CLIENTE.NMFANTCLIE,
                CLIENTE.NRPARCNEGOCIO,
                NOTAFISCAL.IDENTRSAIDOP,
                NOTAFISCAL.DTEMISSAO AS DTEMISSAO,
                NOTAFISCAL.VRNOTAFISC,
                NOTAFISCAL.NRORG
                FROM NOTAFISCAL
                JOIN FILIAL ON FILIAL.CDFILIAL = NOTAFISCAL.CDFILIAL
                AND FILIAL.NRORG = NOTAFISCAL.NRORG
                JOIN CLIENTE ON CLIENTE.CDCLIENTE = NOTAFISCAL.CDCLIENTE
                AND CLIENTE.NRORG = NOTAFISCAL.NRORG
                WHERE IDENTRSAIDOP = 'S' 
                AND CLIENTE.NRPARCNEGOCIO = :NRPARCNEGOCIO 
                AND NOTAFISCAL.NRNOTAFISC != 'null'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function getTabItensApuracaoFaturamento($parametro)
    {
        $sql = "SELECT ITFAT.NRITFATURACONT,
                    ITFAT.NRFATURACONT,
                    ITFAT.NRSEQCONTRATO,
                    ITFAT.NRITEMOCONTRATO,
                    ITCONT.NMITEMCONTRATO,
                    ITFAT.CDPRODFATURA,
                    ITFAT.IDSITUACAO,
                    ITFAT.VRVENCIMENTO,
                    ITFAT.VRFATURADO,
                    ITFAT.VRFALTAFATURAR,
                    ITFAT.IDFORMAFATURA,
                    ITFAT.DSJUSTIFICATIVA,
                    ITFAT.NRAPURACAO,
                    ITFAT.IDATIVO,
                    ITFAT.NRORG,
                    ITFAT.DTINCLUSAO,
                    ITFAT.NRORGINCLUSAO,
                    ITFAT.CDOPERINCLUSAO,
                    ITFAT.DTULTATU,
                    ITFAT.NRORGULTATU,
                    ITFAT.CDOPERULTATU,
                    CONT.NRCONTRATOFCT|| ' - '|| CONT.DSREFERENCIACONT AS NRCONTRATOFCT,
                    ITFAT.VRNEGCONTR,
                    ITFAT.NRPARCELASNEGCONTR,
                    ITFAT.NRESTRUTURAM,
                    LOCAL.NMESTRUTURAM
                FROM FCT_ITFATURACONT ITFAT
                INNER JOIN FCT_ITEMCONTRATO ITCONT ON ITFAT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                AND ITFAT.NRORG = ITCONT.NRORG
                INNER JOIN FCT_CONTRATO CONT ON ITFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND ITFAT.NRORG = CONT.NRORG
                LEFT JOIN ESTRUTURAM LOCAL ON ITFAT.NRESTRUTURAM = LOCAL.NRESTRUTURAM
                WHERE ITFAT.NRFATURACONT = :NRFATURACONT
                ORDER BY NRSEQCONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function getTabDadosAgrupamentos($parametro)
    {
        $sql = "SELECT DISTINCT AGRUPFAT.NRAGRUPCONTFAT,
                        AGRUPFAT.NRFATURACONT,
                        AGRUPFAT.NRORG,
                        CONT.NRSEQCONTRATO,
                        CONT.NRCONTRATOFCT || ' - ' || CONT.DSREFERENCIACONT AS NRCONTRATOFCT,
                        CONT.IDSITUACAOCONTRATO,

                (SELECT SUM(VRVENCIMENTO)
                FROM FCT_ITFATURACONT
                WHERE NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND NRFATURACONT = AGRUPFAT.NRFATURACONT) AS VRVENCIMENTO,
                        MEDICAO.NRMEDICAOFATURA,
                        DECODE(CONT.IDSITUACAOCONTRATO, 'A', DECODE(MEDICAO.NRMEDICAOFATURA, NULL, DECODE(FAT.NRFATURACONT, NULL, CONT.IDSITUACAOCONTRATO, 'PG'), DECODE(NVL(MEDICAO.IDSITUACAO, 4), 4, 'PG', 'AM')), CONT.IDSITUACAOCONTRATO) AS IDSITUACAOPARCELA,
                        NVL(MEDICAO.IDSITUACAO, 4) AS IDSITUACAO,
                        DECODE(AGRUPCONT.NRAGRUPAMENTO, NULL, 'Agrupamento de Parcelas', 'Agrupamento de Contratos') AS TPAGRUPAMENTO,
                        DECODE (FAT.IDTPFATURA,
                                'P',
                                AGRUPFAT.NRPARCELA || '/'||
                                (SELECT COUNT(FCT_FATURACONT.NRFATURACONT) AS CONTADOR
                                FROM FCT_FATURACONT
                                JOIN FCT_RELACAGRUPCONTFAT ON FCT_RELACAGRUPCONTFAT.NRFATURACONT = FCT_FATURACONT.NRFATURACONT
                                AND FCT_RELACAGRUPCONTFAT.NRORG = FCT_FATURACONT.NRORG
                                WHERE FCT_RELACAGRUPCONTFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                                    AND FCT_FATURACONT.IDTPFATURA = 'P' ),
                                NULL) AS NRPARCELA
                FROM FCT_FATURACONT FAT
                INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPFAT ON FAT.NRFATURACONT = AGRUPFAT.NRFATURACONT
                AND FAT.NRORG = AGRUPFAT.NRORG
                LEFT JOIN FCT_RELACAGRUPAMENTOCONT AGRUPCONT ON AGRUPFAT.NRSEQCONTRATO = AGRUPCONT.NRSEQCONTRATO
                AND AGRUPFAT.NRORG = AGRUPCONT.NRORG
                LEFT JOIN FCT_CONTRATO CONT ON AGRUPFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND AGRUPFAT.NRORG = CONT.NRORG
                LEFT JOIN FCT_MEDICAOFATURA MEDICAO ON AGRUPFAT.NRMEDICAOFATURA = MEDICAO.NRMEDICAOFATURA
                AND AGRUPFAT.NRSEQCONTRATO = MEDICAO.NRSEQCONTRATO
                AND AGRUPFAT.NRORG = MEDICAO.NRORG
                WHERE IDPARCAGRUP = 'S'
                AND FAT.NRFATURACONT = :NRFATURACONT
                ORDER BY LPAD(NRPARCELA, 10)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function getModalErroApuracaoFaturamento($parametro)
    {
        $sql = "SELECT DISTINCT ERRO.NRFATURACONT,
                        DECODE(REL.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, 'AGRUPAMENTO') AS NRCONTRATOFCT,
                        PARC.NMPRINCIPALPARC,
                        PARC.NMSECUNDARIPARC,
                        TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS DTINICOMPET,
                        TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS DTFINCOMPET,
                        FAT.VRFALTAFATURAR,
                        ERRO.DSERRO,
                        ERRO.CDOPERADOR,
                        ERRO.DTINCLUSAO,
                        ERRO.NRORG
                FROM FCT_ERROSAPURACAOFATURA ERRO
                JOIN FCT_FATURACONT FAT ON ERRO.NRFATURACONT = FAT.NRFATURACONT
                JOIN FCT_RELACAGRUPCONTFAT REL ON FAT.NRFATURACONT = REL.NRFATURACONT
                JOIN FCT_CONTRATO CONT ON REL.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                JOIN PARCNEGOCIO PARC ON FAT.NRPARCFATURA = PARC.NRPARCNEGOCIO
                WHERE ERRO.CDOPERADOR = :CDOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function validarAgrupamentoFat(array $params)
    {
        $sql = "SELECT CONT.NRCONTRATOFCT,
                        RELCONT.NRSEQCONTRATO,
                        RELCONT.NRORG
                FROM FCT_RELACAGRUPAMENTOCONT RELCONT
                JOIN FCT_CONTRATO CONT
                    ON RELCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                    AND RELCONT.NRORG        = CONT.NRORG
                WHERE RELCONT.NRAGRUPAMENTO IN (
                        SELECT DISTINCT NRAGRUPAMENTO
                        FROM FCT_RELACAGRUPAMENTOCONT
                        WHERE (INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(NRSEQCONTRATO) || '_') > 0)
                    )
                    AND RELCONT.NRSEQCONTRATO NOT IN (
                        SELECT NRSEQCONTRATO
                        FROM FCT_RELACAGRUPCONTFAT
                        WHERE NRFATURACONT = :NRFATURACONT
                    )
                    AND RELCONT.NRSEQCONTRATO IN (
                        SELECT NRSEQCONTRATO
                        FROM FCT_CONTRATO
                        WHERE IDSITUACAOCONTRATO = 'P'
                        UNION ALL 
                        SELECT NRSEQCONTRATO
                        FROM FCT_MEDICAOFATURA
                        WHERE NRPARCFATURA        = :NRPARCFATURA
                        AND TRUNC(DTINICOMPET) >= :DTINICIO 
                        AND TRUNC(DTINICOMPET) <= :DTFIM
                        AND ((IDSITUACAO = '3' AND VRMEDICAO <> 0)
                                OR IDSITUACAO IN ('2', '1'))        
                    )
                    AND RELCONT.NRORG = :NRORG";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function alterarDataSaidaDaNotaFiscal(array $params)
    {
        $sql = "UPDATE NOTAFISCAL
                SET IDSTATUS     = :IDSTATUS,
                    DTENTRSAID   = :DTENTRSAID,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORG
                WHERE CDFILIAL   = :CDFILIAL  
                  AND NRLANCTONF = :NRLANCTONF
                  AND NRORG      = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function alterarSituacaoParcela(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                SET IDSITUACAO   = :IDSITUACAO,
                    DTULTATU     = SYSDATE,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORG 
                WHERE NRFATURACONT = :NRFATURACONT
                    AND NRORG      = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function alterarSituacaoItens(array $params)
    {
        $sql = "UPDATE FCT_ITFATURACONT
                SET IDSITUACAO   = :IDSITUACAO,
                    DTULTATU     = SYSDATE,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORG 
                WHERE NRFATURACONT = :NRFATURACONT
                    AND NRORG      = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function getJustificativa($parametro)
    {
        $sql = "SELECT DSJUSTIFICATIVA
                FROM FCT_FATURACONT
                WHERE NRFATURACONT  = :NRFATURACONT
                  AND NRORG         = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function anularApuracao(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                SET DSJUSTIFICATIVA = :DSJUSTIFICATIVA,
                    IDSITUACAO      = '4',
                    VRFATURADO      = 0,
                    VRFALTAFATURAR  = VRVENCIMENTO,
                    DTULTATU        = SYSDATE,
                    NRORGULTATU     = :NRORG,
                    CDOPERULTATU    = :CDOPERADOR
                WHERE NRFATURACONT    = :NRFATURACONT
                AND NRORG         = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function invoiceValidateHasAlreadyBeenUsed($nrLanctoNF, $cdFilial)
    {
        $sql = "SELECT CONT.NRCONTRATOFCT,
                        TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS DTINICOMPET,
                        TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS DTFINCOMPET,
                        NRCONTRATOFCT || ' - ' ||TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') ||' até ' ||TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS MESSAGE
                FROM FCT_APURACAO APU
                JOIN FCT_RELACAPURACAOFATURA RELAPU
                ON APU.NRAPURACAO = RELAPU.NRAPURACAO
                JOIN FCT_FATURACONT FAT
                ON RELAPU.NRFATURACONT = FAT.NRFATURACONT
                JOIN FCT_RELACAGRUPCONTFAT RELFAT
                ON FAT.NRFATURACONT = RELFAT.NRFATURACONT
                JOIN FCT_CONTRATO CONT
                ON RELFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                WHERE APU.NRLANCTONF = :NRLANCTONF
                AND APU.CDFILIAL   = :CDFILIAL";

        $params = array(
            "NRLANCTONF" => $nrLanctoNF,
            "CDFILIAL" => $cdFilial,
        );
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function criaApuracaoManual(array $params)
    {
        $sql = "INSERT INTO FCT_APURACAO
                        (NRAPURACAO, NRSEQCONTRATO, NRTIPOORCAMENTO,
                         NRPARCNEGOCIO, CDMODPGTO, NRGRUPOFATURA,
                         CDEMPRESA, CDFILIAL, NRLANCTONF,
                         IDSITUACAOAPURACAO, VRAPURACAO, VRAPURACAOORIGINAL,
                         DSALTERACAO, CDAGRUPANF, NRORG,
                         DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                  VALUES
                        (:NRAPURACAO, :NRSEQCONTRATO, NULL,
                         :NRPARCFATURA, NULL, :NRGRUPOFATURA,
                         :CDEMPRESA, :CDFILIAL, :NRLANCTONF,
                         'FATURADA', :VRNOTAFISC, :VRVENCIMENTO,
                         NULL, NULL, :NRORG,
                         SYSDATE, :NRORG, :CDOPERADOR)";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirRelacApuracaoFatura(array $params)
    {
        $sql = "INSERT INTO FCT_RELACAPURACAOFATURA (
                    NRAPURACAOFATURA, NRAPURACAO,    NRFATURACONT,
                    NRORG,            IDATIVO,       DTINCLUSAO,
                    DTULTATU,         NRORGINCLUSAO, CDOPERINCLUSAO,
                    NRORGULTATU,      CDOPERULTATU
                ) VALUES (
                    :NRAPURACAOFATURA, :NRAPURACAO,  :NRFATURACONT,
                    :NRORG,            'S',           SYSDATE,
                    NULL,              :NRORG,       :CDOPERADOR,
                    NULL,              NULL
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizaParcelaApuracaoManual(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                SET NRAPURACAO      = :NRAPURACAO,
                    DSJUSTIFICATIVA = :DSJUSTIFICATIVA,
                    IDSITUACAO      = '3',
                    VRFATURADO      = :VRNOTAFISC,
                    VRFALTAFATURAR  = 0,
                    IDFORMAFATURA   = 'M',
                    DTULTATU        = SYSDATE,
                    NRORGULTATU     = :NRORG,
                    CDOPERULTATU    = :CDOPERADOR
              WHERE NRFATURACONT  = :NRFATURACONT
                AND NRORG         = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function validaQtItens(array $params)
    {
        $sql = "SELECT COUNT(*) AS VALIDA 
                  FROM FCT_ITFATURACONT
                 WHERE NRFATURACONT  = :NRFATURACONT
                   AND NRORG = :NRORG";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function getItensDesmembramento($parametro)
    {
        $sql = "SELECT ITFAT.NRITFATURACONT,
                        ITFAT.NRFATURACONT,
                        ITFAT.NRSEQCONTRATO,
                        ITFAT.NRITEMOCONTRATO,
                        ITCONT.NMITEMCONTRATO|| ' - ' ||CONT.NRCONTRATOFCT AS NMITEMCONTRATO,
                        ITFAT.CDPRODFATURA,
                        ITFAT.IDSITUACAO,
                        ITFAT.VRVENCIMENTO,
                        ITFAT.VRFATURADO,
                        ITFAT.VRFALTAFATURAR,
                        ITFAT.IDFORMAFATURA,
                        ITFAT.DSJUSTIFICATIVA,
                        ITFAT.NRAPURACAO,
                        ITFAT.IDATIVO,
                        ITFAT.NRORG,
                        ITFAT.DTINCLUSAO,
                        ITFAT.NRORGINCLUSAO,
                        ITFAT.CDOPERINCLUSAO,
                        ITFAT.DTULTATU,
                        ITFAT.NRORGULTATU,
                        ITFAT.CDOPERULTATU,
                        ITFAT.VRNEGCONTR,
                        ITFAT.NRPARCELASNEGCONTR,
                        ITFAT.NRESTRUTURAM,
                        LOCAL.NMESTRUTURAM
                FROM FCT_ITFATURACONT ITFAT
                INNER JOIN FCT_ITEMCONTRATO ITCONT ON ITFAT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                AND ITFAT.NRORG = ITCONT.NRORG
                INNER JOIN FCT_CONTRATO CONT ON ITFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND ITFAT.NRORG = CONT.NRORG
                LEFT JOIN ESTRUTURAM LOCAL ON ITFAT.NRESTRUTURAM = LOCAL.NRESTRUTURAM
                WHERE ITFAT.NRFATURACONT = :NRFATURACONT
                ORDER BY NRSEQCONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function getDadosParcela(array $params)
    {
        $sql = "SELECT FAT.NRFATURACONT,
                       FAT.NRSEQCONTRATO,
                       FAT.NRGRUPOFATURA,
                       FAT.CDFILIALFATURA,
                       FAT.NRPARCFATURA,
                       FAT.IDTPFATURA,
                       FAT.IDSITUACAO,
                       FAT.DTINICOMPET,
                       FAT.DTFINCOMPET,
                       FAT.DTLIMITEAPU,
                       FAT.DTVENCIMENTO,
                       FAT.NRDIASVENCIMENTO,
                       FAT.QTDIASFATUVENC,
                       FAT.VRVENCIMENTO,
                       FAT.VRFATURADO,
                       FAT.VRFALTAFATURAR,
                       FAT.IDFORMAFATURA,
                       FAT.NRAPURACAO,
                       REL.NRMEDICAOFATURA,
                       FAT.DSJUSTIFICATIVA,
                       FAT.IDATIVO,
                       FAT.NRORG,
                       FAT.CDTIPOOPERFATURA,
                       FAT.CDSERIENF,
                       FAT.CDEMPRESA,
                       FAT.CDINSCESTA,
                       FAT.CDINSCMUNI
                  FROM FCT_FATURACONT FAT
                  LEFT JOIN FCT_RELACAGRUPCONTFAT REL
                    ON FAT.NRFATURACONT = REL.NRFATURACONT
                   AND FAT.NRORG        = REL.NRORG
                 WHERE FAT.NRFATURACONT = :NRFATURACONT
                   AND FAT.NRORG        = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getDadosItem(array $params)
    {
        $sql = "SELECT NRITFATURACONT, NRFATURACONT, NRSEQCONTRATO, NRITEMOCONTRATO, CDPRODFATURA, 
                       IDSITUACAO, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA, 
                       NRAPURACAO, NRORG
                  FROM FCT_ITFATURACONT
                 WHERE NRITFATURACONT = :NRITFATURACONT
                   AND NRFATURACONT   = :NRFATURACONT
                   AND NRORG          = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getQuantidadeParcelasContrato(array $params)
    {
        $sql = "SELECT COUNT(FCT_FATURACONT.NRFATURACONT) AS CONTADOR
                  FROM FCT_FATURACONT
                  JOIN FCT_RELACAGRUPCONTFAT
                    ON FCT_RELACAGRUPCONTFAT.NRFATURACONT = FCT_FATURACONT.NRFATURACONT
                   AND FCT_RELACAGRUPCONTFAT.NRORG        = FCT_FATURACONT.NRORG
                 WHERE FCT_RELACAGRUPCONTFAT.NRSEQCONTRATO = :NRSEQCONTRATO
                   AND FCT_RELACAGRUPCONTFAT.NRORG         = :NRORG
                   AND FCT_FATURACONT.IDTPFATURA           = 'P'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function insereParcelaDesmembramento(array $params)
    {
        $sql = "INSERT INTO FCT_FATURACONT
                    (NRFATURACONT, NRSEQCONTRATO, NRGRUPOFATURA, CDFILIALFATURA, NRPARCFATURA, IDTPFATURA, 
                     IDSITUACAO, DTINICOMPET, DTFINCOMPET, DTLIMITEAPU, DTVENCIMENTO, NRDIASVENCIMENTO, 
                     QTDIASFATUVENC, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA, DSJUSTIFICATIVA, 
                     NRAPURACAO, NRMEDICAOFATURA, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO,
                     CDTIPOOPERFATURA, CDSERIENF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRPARCELA)
                VALUES 
                    (:NRFATURACONT, :NRSEQCONTRATO, :NRGRUPOFATURA, :CDFILIALFATURA, :NRPARCFATURA, :IDTPFATURA, 
                     :IDSITUACAO, :DTINICOMPET, :DTFINCOMPET, :DTLIMITEAPU, :DTVENCIMENTO, :NRDIASVENCIMENTO, 
                     :QTDIASFATUVENC, :VRVENCIMENTO, :VRFATURADO, :VRFALTAFATURAR, :IDFORMAFATURA, :DSJUSTIFICATIVA, 
                     :NRAPURACAO, :NRMEDICAOFATURA, 'S', :NRORG, SYSDATE, :NRORG, :OPERADOR, :CDTIPOOPERFATURA, :CDSERIENF,
                     :CDEMPRESA, :CDINSCESTA, :CDINSCMUNI, :NRPARCELA)";

        $this->connection->executeStatement($sql, $params);
    }

    public function salvarRelacAgrupContFat($params)
    {
        $sql = "INSERT INTO FCT_RELACAGRUPCONTFAT(
                    NRAGRUPCONTFAT,   IDPARCAGRUP,  NRSEQCONTRATO,  NRORG, 
                    DTINCLUSAO,       DTULTATU,     NRORGINCLUSAO,  CDOPERINCLUSAO, 
                    NRORGULTATU,      CDOPERULTATU, NRFATURACONT,   NRMEDICAOFATURA,
                    IDATIVO
                ) VALUES (
                    :NRAGRUPCONTFAT,  :IDPARCAGRUP,  :NRSEQCONTRATO,  :NRORG, 
                    SYSDATE,          NULL,          :NRORG,          :OPERADOR, 
                    :NRORG,           :OPERADOR,     :NRFATURACONT,   :NRMEDICAOFATURA,
                    'S'
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function getItemsFatura($params, $nrfaturacont)
    {
        $sql = "SELECT NRITFATURACONT, NRFATURACONT, NRSEQCONTRATO, NRITEMOCONTRATO, CDPRODFATURA, 
                       IDSITUACAO, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA, 
                       NRAPURACAO, NRORG
                  FROM FCT_ITFATURACONT
                 WHERE NRFATURACONT  IN ($nrfaturacont)
                   AND (NRSEQCONTRATO = :NRSEQCONTRATO
                        OR :NRSEQCONTRATO IS NULL)
                   AND NRORG         = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function insereItemDesmembramento(array $params)
    {
        $sql = "INSERT INTO FCT_ITFATURACONT 
                   (NRITFATURACONT, NRFATURACONT, NRSEQCONTRATO, NRITEMOCONTRATO, CDPRODFATURA, 
                    IDSITUACAO, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA, 
                    DSJUSTIFICATIVA, NRAPURACAO, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                VALUES
                   (:NRITFATURACONT, :NRFATURACONT, :NRSEQCONTRATO, :NRITEMOCONTRATO, :CDPRODFATURA, 
                    :IDSITUACAO, :VRVENCIMENTO, :VRFATURADO, :VRFALTAFATURAR, :IDFORMAFATURA, 
                    :DSJUSTIFICATIVA, :NRAPURACAO, 'S', :NRORG, SYSDATE, :NRORG, :OPERADOR)";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizaValorParcelaNova(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                   SET VRVENCIMENTO   = VRVENCIMENTO + :VRVENCIMENTO,
                       VRFALTAFATURAR = VRFALTAFATURAR + :VRVENCIMENTO
                 WHERE NRFATURACONT = :NRFATURACONT
                   AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function deletaItemParcelaOrigem(array $params)
    {
        $sql = "DELETE FROM FCT_ITFATURACONT
                 WHERE (NRITFATURACONT = :NRITFATURACONT
                        OR :NRITFATURACONT IS NULL)
                   AND NRFATURACONT = :NRFATURACONT
                   AND (NRSEQCONTRATO = :NRSEQCONTRATO
                        OR :NRSEQCONTRATO IS NULL)
                   AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizaValorParcelaOrigem(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                   SET VRVENCIMENTO   = VRVENCIMENTO - :VRVENCIMENTO,
                       VRFALTAFATURAR = VRFALTAFATURAR - :VRVENCIMENTO,
                       DSJUSTIFICATIVA = :DSJUSTIFICATIVA
                 WHERE NRFATURACONT = :NRFATURACONT
                   AND NRORG        = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function getInformacoesRelacParcelaCont($nrfaturacont, array $params)
    {
        $sql = "SELECT NRSEQCONTRATO,
                    NRMEDICAOFATURA
                FROM FCT_RELACAGRUPCONTFAT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = :NRORG
                    AND (NRSEQCONTRATO = :NRSEQCONTRATO OR :NRSEQCONTRATO IS NULL)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function deletarParcelaFatura($nrfaturacont, $nrorg)
    {
        $sql = "DELETE FROM FCT_FATURACONT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = $nrorg";
        $this->connection->executeStatement($sql);
    }

    public function alterarInfoAgrupamentoParcela($params)
    {
        $sql = "UPDATE FCT_RELACAGRUPCONTFAT
                SET IDPARCAGRUP  = 'N',
                    CDOPERULTATU = :CDOPERADOR
                WHERE NRFATURACONT  = :NRFATURACONT
                   AND NRORG        = :NRORG";
        $this->connection->executeStatement($sql, $params);
    }

    public function deletarRelacAgrupamentoContFat($nrfaturacont, array $params)
    {
        $sql = "DELETE FROM FCT_RELACAGRUPCONTFAT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = :NRORG
                    AND (NRSEQCONTRATO = :NRSEQCONTRATO 
                            OR :NRSEQCONTRATO IS NULL)";
        $this->connection->executeStatement($sql, $params);
    }
    
}
