<?php

namespace SM\Service;

use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Zeedhi\Framework\Remote\cURLRequest;

class FileServerService
{

    protected $Environment;
    protected $newCode;
    protected $fileServerApiKeys;
    protected $fileServerUrl;
    // protected $tempDir;

    public function __construct(Environment $Environment, NewCode $newCode, $fileServerApiKeys, $fileServerUrl)
    {
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->fileServerApiKeys = $fileServerApiKeys;
        $this->fileServerUrl = $fileServerUrl;
        // $this->tempDir = sys_get_temp_dir();
    }

    public function uploadFiles($params, $customFolder)
    {
        $nrorg = $this->Environment->getNrOrg();
        if (isset($this->fileServerApiKeys[$nrorg])) {
            $key = $this->fileServerApiKeys[$nrorg];
            $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
            $row = array('FILE' => $params);
            $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);
            return $row['FILE'];
        } else {
            throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado.");
        }
    }

    public function deleteFile($link)
    {
        $nrorg = $this->Environment->getNrOrg();
        $key = $this->fileServerApiKeys[$nrorg];
        $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
        $zhFileUploader->deleteFile($link);
    }

    public function getDocumentoFileServer($urlArquivo, $nrorg)
    {
        $header = array (
            "apiKey: " . $this->fileServerApiKeys[$nrorg]
        );
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $urlArquivo);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 90);

        $resultado = curl_exec($ch);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($error)) {
            throw new \Exception($error);
        }

        if (strpos($resultado, "404 Not Found") !== false) {
            //throw new \Exception($resultado);
            return false;
        } else {
            return $resultado;
        }
    }

    public function downloadDocFileServer($caminhoArquivo, $nrorg)
    {
        $urlArquivo = $this->fileServerUrl .'/files/'. $caminhoArquivo;
        $conteudoArquivo = $this->getDocumentoFileServer($urlArquivo, $nrorg);
        if ($conteudoArquivo !== false) {
            return $urlArquivo;
            /* if (is_dir($this->tempDir) && is_writable($this->tempDir)) {
                $caminhoFisicoArquivo = $this->tempDir . DIRECTORY_SEPARATOR . $nomeArquivoParaSalvar;
                file_put_contents($caminhoFisicoArquivo, $conteudoArquivo);
                return $caminhoFisicoArquivo;
            }
            else {
                throw new \Exception("Falha ao salvar o documento. <br/>O diretório \"".$this->tempDir."\" não existe ou não possui permissão para escrita.");
            } */
        } else {
            throw new \Exception("Falha ao baixar o documento. <br/>O arquivo correspondente à URL \"" . $urlArquivo . "\" não existe.");
        }
    }
}
